// Thunderbird specific functions for MinimizeToTray

if (!('extensions' in window))
    window.extensions = new Array();

if (!('mook' in window.extensions))
    window.extensions.mook = new Array();

if (!('minimizetotray' in window.extensions.mook))
    window.extensions.mook.minimizetotray = 
    function(){
        // this is a stub only
        throw Components.results.NS_ERROR_ABORT;
    };

    window.extensions.mook.minimizetotray
.trayCallback = 
function ( aEvent, aParam, aKeyMask, aMouseX, aMouseY ) {
    // note that |this| is the function itself
    var self = window.extensions.mook.minimizetotray;
    var iface = Components.interfaces.trayIWindowCallback;
    var rv = false;
    switch (aEvent) {
        case iface.EVENT_MOUSEUP_LEFT:
            self.restore();
            rv = true;
            break;
        case iface.EVENT_MOUSEUP_RIGHT:
        {
            var popup = document.getElementById(
                self.k_xul_prefix + 'traypopup');
            self.showPopup( popup, aMouseX, aMouseY );
            rv = true;
            break;
        }
    }
    return rv;
};

    window.extensions.mook.minimizetotray
.turboMode = 
function ( ) {
    var self = window.extensions.mook.minimizetotray;
    self.noBinaryComponentWarning();
    
    // look for existing -turbo mode windows
    var wm = 
        Components.classes["@mozilla.org/appshell/window-mediator;1"]
            .getService(Components.interfaces.nsIWindowMediator);
    var e = wm.getEnumerator(null);
    while (e.hasMoreElements()) {
        var w = e.getNext();
        if ('extensions' in w && 'mook' in w.extensions &&
          'minimizetotray' in w.extensions.mook &&
          w.extensions.mook.minimizetotray.m_isTurboMode)
            // a turbo mode window already exists
            return;
    }
    
    // make the -turbo mode window
    self.m_windowHider =
        Components.classes[self.k_contractid_windowHider]
            .createInstance(Components.interfaces.trayIWindowHider);
    var docShells = [self.getDocShell(window)];
    self.m_isHidden = [window];
    
    // for Tbird, there is no turbo mode, since there can only
    // ever be one window open
    self.m_windowHider.minimize(
        docShells.length, 
        docShells,
        self.trayCallback);
    
    self.m_isTurboMode = true;
};

// signal that the app-specific parts have done loading
window.extensions.mook.minimizetotray.m_bLoadedApp = true;
